---
title: Get a tag pipeline ruleset
description: Datadog, the leading service for cloud-scale monitoring.
breadcrumbs: Docs > API Reference > Cloud Cost Management
---

# Get a tag pipeline ruleset{% #get-a-tag-pipeline-ruleset %}
Copy pageCopied
{% tab title="v2" %}

| Datadog site      | API endpoint                                                          |
| ----------------- | --------------------------------------------------------------------- |
| ap1.datadoghq.com | GET https://api.ap1.datadoghq.com/api/v2/tags/enrichment/{ruleset_id} |
| ap2.datadoghq.com | GET https://api.ap2.datadoghq.com/api/v2/tags/enrichment/{ruleset_id} |
| app.datadoghq.eu  | GET https://api.datadoghq.eu/api/v2/tags/enrichment/{ruleset_id}      |
| app.ddog-gov.com  | GET https://api.ddog-gov.com/api/v2/tags/enrichment/{ruleset_id}      |
| us2.ddog-gov.com  | GET https://api.us2.ddog-gov.com/api/v2/tags/enrichment/{ruleset_id}  |
| app.datadoghq.com | GET https://api.datadoghq.com/api/v2/tags/enrichment/{ruleset_id}     |
| us3.datadoghq.com | GET https://api.us3.datadoghq.com/api/v2/tags/enrichment/{ruleset_id} |
| us5.datadoghq.com | GET https://api.us5.datadoghq.com/api/v2/tags/enrichment/{ruleset_id} |

### Overview

Get a specific tag pipeline ruleset - Retrieve a specific tag pipeline ruleset by its ID

OAuth apps require the `cloud_cost_management_read` authorization [scope](https://docs.datadoghq.com/api/latest/scopes.md#cloud-cost-management) to access this endpoint.



### Arguments

#### Path Parameters

| Name                         | Type   | Description                          |
| ---------------------------- | ------ | ------------------------------------ |
| ruleset_id [*required*] | string | The unique identifier of the ruleset |

### Response

{% tab title="200" %}
OK
{% tab title="Model" %}
The definition of `RulesetResp` object.

| Parent field         | Field                                     | Type     | Description                                                                                     |
| -------------------- | ----------------------------------------- | -------- | ----------------------------------------------------------------------------------------------- |
|                      | data                                      | object   | The definition of `RulesetRespData` object.                                                     |
| data                 | attributes                                | object   | The definition of `RulesetRespDataAttributes` object.                                           |
| attributes           | created [*required*]                 | object   | The definition of `RulesetRespDataAttributesCreated` object.                                    |
| created              | nanos                                     | int32    | The `created` `nanos`.                                                                          |
| created              | seconds                                   | int64    | The `created` `seconds`.                                                                        |
| attributes           | enabled [*required*]                 | boolean  | The `attributes` `enabled`.                                                                     |
| attributes           | last_modified_user_uuid [*required*] | string   | The `attributes` `last_modified_user_uuid`.                                                     |
| attributes           | modified [*required*]                | object   | The definition of `RulesetRespDataAttributesModified` object.                                   |
| modified             | nanos                                     | int32    | The `modified` `nanos`.                                                                         |
| modified             | seconds                                   | int64    | The `modified` `seconds`.                                                                       |
| attributes           | name [*required*]                    | string   | The `attributes` `name`.                                                                        |
| attributes           | position [*required*]                | int32    | The `attributes` `position`.                                                                    |
| attributes           | processing_status                         | string   | The `attributes` `processing_status`.                                                           |
| attributes           | rules [*required*]                   | [object] | The `attributes` `rules`.                                                                       |
| rules                | enabled [*required*]                 | boolean  | The `items` `enabled`.                                                                          |
| rules                | mapping                                   | object   | The definition of `DataAttributesRulesItemsMapping` object.                                     |
| mapping              | destination_key [*required*]         | string   | The `mapping` `destination_key`.                                                                |
| mapping              | if_not_exists                             | boolean  | **DEPRECATED**: Deprecated. Use `if_tag_exists` instead. The `mapping` `if_not_exists`.         |
| mapping              | if_tag_exists                             | enum     | The behavior when the tag already exists. Allowed enum values: `append,do_not_apply,replace`    |
| mapping              | source_keys [*required*]             | [string] | The `mapping` `source_keys`.                                                                    |
| rules                | metadata                                  | object   | The `items` `metadata`.                                                                         |
| additionalProperties | <any-key>                                 | string   |
| rules                | name [*required*]                    | string   | The `items` `name`.                                                                             |
| rules                | query                                     | object   | The definition of `RulesetRespDataAttributesRulesItemsQuery` object.                            |
| query                | addition [*required*]                | object   | The definition of `RulesetRespDataAttributesRulesItemsQueryAddition` object.                    |
| addition             | key [*required*]                     | string   | The `addition` `key`.                                                                           |
| addition             | value [*required*]                   | string   | The `addition` `value`.                                                                         |
| query                | case_insensitivity                        | boolean  | The `query` `case_insensitivity`.                                                               |
| query                | if_not_exists                             | boolean  | **DEPRECATED**: Deprecated. Use `if_tag_exists` instead. The `query` `if_not_exists`.           |
| query                | if_tag_exists                             | enum     | The behavior when the tag already exists. Allowed enum values: `append,do_not_apply,replace`    |
| query                | query [*required*]                   | string   | The `query` `query`.                                                                            |
| rules                | reference_table                           | object   | The definition of `RulesetRespDataAttributesRulesItemsReferenceTable` object.                   |
| reference_table      | case_insensitivity                        | boolean  | The `reference_table` `case_insensitivity`.                                                     |
| reference_table      | field_pairs [*required*]             | [object] | The `reference_table` `field_pairs`.                                                            |
| field_pairs          | input_column [*required*]            | string   | The `items` `input_column`.                                                                     |
| field_pairs          | output_key [*required*]              | string   | The `items` `output_key`.                                                                       |
| reference_table      | if_not_exists                             | boolean  | **DEPRECATED**: Deprecated. Use `if_tag_exists` instead. The `reference_table` `if_not_exists`. |
| reference_table      | if_tag_exists                             | enum     | The behavior when the tag already exists. Allowed enum values: `append,do_not_apply,replace`    |
| reference_table      | source_keys [*required*]             | [string] | The `reference_table` `source_keys`.                                                            |
| reference_table      | table_name [*required*]              | string   | The `reference_table` `table_name`.                                                             |
| attributes           | version [*required*]                 | int64    | The `attributes` `version`.                                                                     |
| data                 | id                                        | string   | The `RulesetRespData` `id`.                                                                     |
| data                 | type [*required*]                    | enum     | Ruleset resource type. Allowed enum values: `ruleset`                                           |

{% /tab %}

{% tab title="Example" %}

```json
{
  "data": {
    "attributes": {
      "created": null,
      "enabled": true,
      "last_modified_user_uuid": "",
      "modified": null,
      "name": "Example Ruleset",
      "position": 0,
      "rules": [
        {
          "enabled": false,
          "mapping": null,
          "metadata": null,
          "name": "RC test rule edited1",
          "query": {
            "addition": {
              "key": "abc",
              "value": "ww"
            },
            "case_insensitivity": false,
            "if_tag_exists": "do_not_apply",
            "query": "billingcurrency:\"USD\" AND account_name:\"SZA96462\" AND billingcurrency:\"USD\""
          },
          "reference_table": null
        },
        {
          "enabled": true,
          "mapping": {
            "destination_key": "h",
            "if_tag_exists": "do_not_apply",
            "source_keys": [
              "accountname",
              "accountownerid"
            ]
          },
          "metadata": null,
          "name": "rule with empty source key",
          "query": null,
          "reference_table": null
        },
        {
          "enabled": true,
          "mapping": null,
          "metadata": null,
          "name": "New table rule with new UI",
          "query": null,
          "reference_table": {
            "case_insensitivity": true,
            "field_pairs": [
              {
                "input_column": "status_type",
                "output_key": "status"
              },
              {
                "input_column": "status_description",
                "output_key": "dess"
              }
            ],
            "if_tag_exists": "append",
            "source_keys": [
              "http_status",
              "status_description"
            ],
            "table_name": "http_status_codes"
          }
        }
      ],
      "version": 1
    },
    "id": "12345",
    "type": "ruleset"
  }
}
```

{% /tab %}

{% /tab %}

{% tab title="429" %}
Too many requests
{% tab title="Model" %}
API error response.

| Field                    | Type     | Description       |
| ------------------------ | -------- | ----------------- |
| errors [*required*] | [string] | A list of errors. |

{% /tab %}

{% tab title="Example" %}

```json
{
  "errors": [
    "Bad Request"
  ]
}
```

{% /tab %}

{% /tab %}

### Code Example

##### 
                  \# Path parameters export ruleset_id="CHANGE_ME" \# Curl command curl -X GET "https://api.datadoghq.com/api/v2/tags/enrichment/${ruleset_id}" \
-H "Accept: application/json" \
-H "DD-API-KEY: ${DD_API_KEY}" \
-H "DD-APPLICATION-KEY: ${DD_APP_KEY}" 
                
##### 

```python
"""
Get a tag pipeline ruleset returns "OK" response
"""

from datadog_api_client import ApiClient, Configuration
from datadog_api_client.v2.api.cloud_cost_management_api import CloudCostManagementApi

configuration = Configuration()
with ApiClient(configuration) as api_client:
    api_instance = CloudCostManagementApi(api_client)
    response = api_instance.get_tag_pipelines_ruleset(
        ruleset_id="a1e9de9b-b88e-41c6-a0cd-cc0ebd7092de",
    )

    print(response)
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=python) and then save the example to `example.py` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" python3 "example.py"
##### 

```ruby
# Get a tag pipeline ruleset returns "OK" response

require "datadog_api_client"
api_instance = DatadogAPIClient::V2::CloudCostManagementAPI.new
p api_instance.get_tag_pipelines_ruleset("a1e9de9b-b88e-41c6-a0cd-cc0ebd7092de")
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=ruby) and then save the example to `example.rb` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" rb "example.rb"
##### 

```go
// Get a tag pipeline ruleset returns "OK" response

package main

import (
	"context"
	"encoding/json"
	"fmt"
	"os"

	"github.com/DataDog/datadog-api-client-go/v2/api/datadog"
	"github.com/DataDog/datadog-api-client-go/v2/api/datadogV2"
)

func main() {
	ctx := datadog.NewDefaultContext(context.Background())
	configuration := datadog.NewConfiguration()
	apiClient := datadog.NewAPIClient(configuration)
	api := datadogV2.NewCloudCostManagementApi(apiClient)
	resp, r, err := api.GetTagPipelinesRuleset(ctx, "a1e9de9b-b88e-41c6-a0cd-cc0ebd7092de")

	if err != nil {
		fmt.Fprintf(os.Stderr, "Error when calling `CloudCostManagementApi.GetTagPipelinesRuleset`: %v\n", err)
		fmt.Fprintf(os.Stderr, "Full HTTP response: %v\n", r)
	}

	responseContent, _ := json.MarshalIndent(resp, "", "  ")
	fmt.Fprintf(os.Stdout, "Response from `CloudCostManagementApi.GetTagPipelinesRuleset`:\n%s\n", responseContent)
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=go) and then save the example to `main.go` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" go run "main.go"
##### 

```java
// Get a tag pipeline ruleset returns "OK" response

import com.datadog.api.client.ApiClient;
import com.datadog.api.client.ApiException;
import com.datadog.api.client.v2.api.CloudCostManagementApi;
import com.datadog.api.client.v2.model.RulesetResp;

public class Example {
  public static void main(String[] args) {
    ApiClient defaultClient = ApiClient.getDefaultApiClient();
    CloudCostManagementApi apiInstance = new CloudCostManagementApi(defaultClient);

    try {
      RulesetResp result =
          apiInstance.getTagPipelinesRuleset("a1e9de9b-b88e-41c6-a0cd-cc0ebd7092de");
      System.out.println(result);
    } catch (ApiException e) {
      System.err.println("Exception when calling CloudCostManagementApi#getTagPipelinesRuleset");
      System.err.println("Status code: " + e.getCode());
      System.err.println("Reason: " + e.getResponseBody());
      System.err.println("Response headers: " + e.getResponseHeaders());
      e.printStackTrace();
    }
  }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=java) and then save the example to `Example.java` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" java "Example.java"
##### 

```rust
// Get a tag pipeline ruleset returns "OK" response
use datadog_api_client::datadog;
use datadog_api_client::datadogV2::api_cloud_cost_management::CloudCostManagementAPI;

#[tokio::main]
async fn main() {
    let configuration = datadog::Configuration::new();
    let api = CloudCostManagementAPI::with_config(configuration);
    let resp = api
        .get_tag_pipelines_ruleset("a1e9de9b-b88e-41c6-a0cd-cc0ebd7092de".to_string())
        .await;
    if let Ok(value) = resp {
        println!("{:#?}", value);
    } else {
        println!("{:#?}", resp.unwrap_err());
    }
}
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=rust) and then save the example to `src/main.rs` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" cargo run
##### 

```typescript
/**
 * Get a tag pipeline ruleset returns "OK" response
 */

import { client, v2 } from "@datadog/datadog-api-client";

const configuration = client.createConfiguration();
const apiInstance = new v2.CloudCostManagementApi(configuration);

const params: v2.CloudCostManagementApiGetTagPipelinesRulesetRequest = {
  rulesetId: "a1e9de9b-b88e-41c6-a0cd-cc0ebd7092de",
};

apiInstance
  .getTagPipelinesRuleset(params)
  .then((data: v2.RulesetResp) => {
    console.log(
      "API called successfully. Returned data: " + JSON.stringify(data)
    );
  })
  .catch((error: any) => console.error(error));
```

#### Instructions

First [install the library and its dependencies](https://docs.datadoghq.com/api/latest.md?code-lang=typescript) and then save the example to `example.ts` and run following commands:
    DD_SITE="datadoghq.com" DD_API_KEY="<DD_API_KEY>" DD_APP_KEY="<DD_APP_KEY>" tsc "example.ts"
{% /tab %}
